using System;
using System.Collections;
using System.ComponentModel;
using System.Drawing;
using System.Data;
using System.Text;
using System.Windows.Forms;

namespace Wizard
{
    internal class KeyEditBox : System.Windows.Forms.TextBox
    {
        private string Base36 = "0123456789ACDEFGHJKLMNPQRTUVWXYZBIOS";
        private string Base32 = "0123456789ACDEFGHJKLMNPQRTUVWXYZ";
        private string Base4 = "BIOS";

        public KeyEditBox()
        {
        }

        protected override void WndProc(ref System.Windows.Forms.Message m)
        {
            if (m.Msg == 0x0302 /*WM_PASTE*/)
            {
                PasteContent();
                return;
            }
            base.WndProc(ref m);
        }

        void PasteContent()
        {
            string topaste = System.Windows.Forms.Clipboard.GetText();
            StringBuilder sb = new StringBuilder();
            for (int i = 0; i < topaste.Length; i++)
            {
                if (sb.Length >= MaxLength) break;
                char c = topaste[i];
                if (sb.Length < MaxLength - 1)
                {
                    if (Base4.IndexOf(c) != -1)
                    {
                        switch (c)
                        {
                            case 'B': c = '8'; break;
                            case 'I': c = '1'; break;
                            case 'O': c = '0'; break;
                            case 'S': c = '5'; break;
                        }
                    }
                    if (Base32.IndexOf(c) < 0) continue;
                }
                else if (Base36.IndexOf(c) < 0) continue;
                if (sb.Length % 6 == 5) sb.Append('-');
                sb.Append(c);
            }
            Text = sb.ToString();
            SelectionStart = Text.Length;
            SelectionLength = 0;
        }

        protected override void OnKeyPress(System.Windows.Forms.KeyPressEventArgs e)
        {
            char c = e.KeyChar;

            if (c == (char)22) { PasteContent(); e.Handled = true; return; }
            if (c == 8) return;
            if (this.SelectedText != "") SelectedText = "";
            if (Text.Length >= MaxLength)
            {
                e.Handled = true;
                //Parent.SelectNextControl(this, true, true, true, true);
                return;
            }
            e.Handled = true;
            c = e.KeyChar.ToString().ToUpper()[0];
            if (Text.Length < MaxLength - 1)
            {
                if (Base4.IndexOf(c) != -1)
                {
                    switch (c)
                    {
                        case 'B': c = '8'; break;
                        case 'I': c = '1'; break;
                        case 'O': c = '0'; break;
                        case 'S': c = '5'; break;
                    }
                }
                if (Base32.IndexOf(c) < 0) return;
            }
            else if (Base36.IndexOf(c) < 0) return;
            if (SelectionLength != 0) Text = Text.Remove(SelectionStart, SelectionLength);
            if (SelectionStart == Text.Length)
            {
                if (Text.Length % 6 == 5) AppendText("-");
                AppendText(c.ToString());
            }
            else
            {
                int s = SelectionStart;
                string after = c.ToString();
                if (s < Text.Length)
                {
                    after += Text.Substring(s).Replace("-", "");
                    Text = Text.Remove(s);
                }
                for (int i = 0; i < after.Length; i++)
                {
                    if (Text.Length % 6 == 5) AppendText("-");
                    AppendText(after[i].ToString());
                }
                SelectionStart = s + 1;
            }
            if (Text.Length == MaxLength) Parent.SelectNextControl(this, true, true, true, true);
        }

    }
}