
using System;
using System.Drawing;
using System.Collections;
using System.Collections.Generic;
using System.ComponentModel;
using System.Windows.Forms;
using System.Data;
using System.Threading;
using System.Runtime.InteropServices;
using System.IO;
using System.Configuration;
using System.Xml;
using PvLogiciels.dotNetProtector;

namespace Wizard
{
	/// <summary>
	/// Description rsume de MainClass.
	/// </summary>
	internal class MainClass
	{
        public static bool siteLicense = false;
        public static bool cbServerChecked=false;
        public static bool cbSiteLicChecked = false;
        public static string serverAddress = string.Empty;
        public static string ProductKey = string.Empty;
        public static string txtServerReponse;
		public static string txtActivationOk;
		public static string txtActivationError;
		public static string txtUnKnownError;
		public static string txtKeyInvalid;
        public static string[] ActivationMessages;

        public static string NetSuffixes = "SDUdu";

        public static ulong PkData = 0;

        public static int PkMultiKind
        {
            get
            {
                return (int)(PkData & 0x1F);
            }
        }

        public static int PkSingleKind
        {
            get
            {
                return (int)((PkData >> 16) & 0x1F);
            }
        }

        public static int PkMultiCount
        {
            get
            {
                return (int)((PkData >> 16) & 0xFFFF);
            }
        }

        public static byte PkFeatures
        {
            get
            {
                return (byte)((PkData >> 8) & 0xFF);
            }
        }

        public static bool PkSubscription
        {
            get
            {
                return (PkData & 0x80) != 0;
            }
        }

        public static bool PkSingle
        {
            get
            {
                return (PkData & 0x1F) == 0;
            }
        }

        public static bool PkMultiple
        {
            get
            {
                return (PkData & 0x1F) != 0;
            }
        }

		static string Key1="";
        internal static int Mode = 0;
        internal static ulong UsbHash = 0;
        internal static ulong UsbIdentity = 0;
        static string stLicence;
        internal static byte[] configBytes = new byte[94];


        static string Perm32 = "0123456789ACDEFGHJKLMNPQRTUVWXYZ";
        static string Perm36 = "0123456789ACDEFGHJKLMNPQRTUVWXYZBIOS";
        static byte[] PkEmpty = { 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0 };

        internal static byte[] Pk2Uid(string pk)
        {
            if (string.IsNullOrEmpty(pk)) return PkEmpty;
            string npk = pk.Replace("-", "");
            if (npk.Length != 25) return PkEmpty;
            byte[] id = new byte[16];
            for (int i = 0; i < 3; i++)
            {
                ulong temp = 0;
                for (int j = 0; j < 8; j++)
                {
                    int v = Perm32.IndexOf(npk[i * 8 + j]);
                    if (v < 0) return PkEmpty;
                    temp <<= 5;
                    temp |= (byte)(v & 0xFF);
                }
                for (int j = 4; j >= 0; j--)
                {
                    id[i * 5 + j] = (byte)(temp & 0xFF);
                    temp >>= 8;
                }
            }
            int tmp = Perm36.IndexOf(npk[24]);
            if (tmp < 0) return PkEmpty;
            id[15] = (byte)(tmp & 0xFF);
            return id;
        }

        internal static ulong ProductKeyData
        {
            get
            {
                ulong val = 0;
                for (int i = 0; i < 8; i++)
                {
                    val <<= 8;
                    val |= configBytes[15 - i];
                }
                return val;
            }
        }

        internal static string ActErrorMsg(string result)
        {
            if (!result.StartsWith("*")) return txtUnKnownError;
            try
            {
                int num = int.Parse(result.Substring(1));
                if (num < 0 || num >= ActivationMessages.Length) return txtUnKnownError;
                return ActivationMessages[num];
            }
            catch
            {
                return txtUnKnownError;
            }
        }

		internal static int Run(IWin32Window owner) 
		{

            string ErrorText = Resources.ErrorText;
            txtServerReponse = Resources.ServerReponse;
            txtActivationOk = Resources.ActivationOk;
            txtActivationError = Resources.ActivationError;
            txtUnKnownError = Resources.UnKnownError;
            txtKeyInvalid = Resources.InvalidKey;
            string msgs = Resources.ActivationMessages;
            ActivationMessages = msgs.Split('|');

            string ConfigString = "";
            //string ProductKey = "";
            string LicenseKey = ""; // c'est un menteur! elle est affecte dans un case.
			string LanguageString=System.Globalization.CultureInfo.CurrentUICulture.TwoLetterISOLanguageName;

            //WizardInit wzInit = new WizardInit();
            //wzInit.ShowDialog(owner);
            //if (wzInit.wzAction == 0)
            //{
            //    wzInit.Dispose();
            //    return 1;
            //}
            //int step = cbServerChecked ? 5 : 1;
            //wzInit.Dispose();
            int step = -1;
            int comefrom = -1;
            int prevstep = -1;
			while(step!=0) 
			{
				switch(step) 
				{
                    case -1:
                        WizardInit wzInit = new WizardInit();
                        wzInit.cbServer.Checked = cbServerChecked;
                        wzInit.ShowDialog(owner);
                        if (wzInit.wzAction == 0)
                        {
                            wzInit.Dispose();
                            return 1;
                        }
                        step = cbServerChecked ? 5 : 1;
                        wzInit.Dispose();
                        break;
					case 1 : 
						WizardKey wzKey = new WizardKey();
						wzKey.Key1.Text=Key1;
						wzKey.ShowDialog(owner);
                        if (wzKey.wzAction == 0)
                        {
                            wzKey.Dispose();
                            return 1;
                        }
						Key1=wzKey.Key1.Text;
                        ProductKey = wzKey.ProductKey;
                        comefrom = prevstep;
                        prevstep = step;
                        bool needServer = PkMultiple && string.IsNullOrEmpty(serverAddress);
                        step = wzKey.wzAction == 2 ? needServer ? 5 : siteLicense ? 3 : 2 : -1;
						break;
					case 2 : 
						WizardMode wzMode = new WizardMode();
                        wzMode.ShowDialog(owner);
                        comefrom = prevstep;
                        prevstep = step;
                        if (wzMode.wzAction == 0)
                        {
                            wzMode.Dispose();
                            return 1;
                        }
						if(wzMode.wzAction==1) 
						{
							step=comefrom;
                            wzMode.Dispose();
							break;
						}
                        Mode = wzMode.Value;
                        
                        if (Mode==255)
                        {
                            step = 3;
                            LicenseKey = "*";
                            wzMode.Dispose();
                            break;
                        }
                        if (Mode>255)
                        {
                            step = 3;
                            LicenseKey = string.Format("@{0}/{1}",serverAddress,NetSuffixes[Mode & 255]);
                            wzMode.Dispose();
                            break;
                        }
                        else if (serverAddress != null)
                        {
                            LicenseKey = string.Format("@{0}/P", serverAddress);
                        }
                        wzMode.Dispose();
                        step = Mode==1?4:3;
						break;
					case 3 : 
						WizardWait wzWait = new WizardWait();
						wzWait.ShowDialog(owner);
                        comefrom = prevstep;
                        prevstep = step;
                        if (wzWait.wzAction == 0)
                        {
                            wzWait.Dispose();
                            return 1;
                        }
                        if (Mode >= 255 || !string.IsNullOrEmpty(serverAddress)) stLicence = LicenseKey; else stLicence = wzWait.stLicence;
						step=(wzWait.wzAction==1)?comefrom:0;
                        wzWait.Dispose();
						break;
					case 4 : 
						WizardUSB wzUSB = new WizardUSB();
                        wzUSB.ShowDialog(owner);
                        comefrom = prevstep;
                        prevstep = step;
                        UsbDetector detector = wzUSB.detector;
                        if (wzUSB.wzAction == 0)
                        {
                            wzUSB.Dispose();
                            return 1;
                        }
                        if (wzUSB.wzAction == 1 || detector==null || detector.FoundDevice==null)
                        {
                            step = 2;
                            UsbHash = UsbIdentity = 0;
                            wzUSB.Dispose();
                            break;
                        }
                        step = 3;
                        if (detector.FoundDevice.Length > 0)
                        {
                            UsbHash = detector.UsbHash;
                            UsbIdentity = detector.UsbIdentity;
                        }
                        else UsbHash = UsbIdentity = 0;
                        //wzUSB.Dispose();
                        //MessageBox.Show("Step=3");
						break;
                    case 5:
                        WizardServer wzServer = new WizardServer();
                        comefrom = prevstep;
                        //if (prevstep == 1)
                        //{
                        //    wzServer.cbSiteLic.Checked = false;
                        //    wzServer.cbSiteLic.Enabled = false;
                        //}
                        //else
                        //{
                        //    wzServer.cbSiteLic.Checked = cbSiteLicChecked;
                        //    wzServer.cbSiteLic.Enabled = true;
                        //}
                        wzServer.ShowDialog(owner);
                        prevstep = step;
                        if (wzServer.wzAction == 0)
                        {
                            wzServer.Dispose();
                            return 1;
                        }
                        step = comefrom == 1 ? 2 : 1;
                        break;
					default: break;
				}
			}
            if (LicenseKey == null) return 1;
            string AssemblyFile = Program.AssemblyToActivate.ManifestModule.Name;
            MemoryStream ms = new MemoryStream();
            StreamWriter sw = new StreamWriter(ms);
            sw.WriteLine("<dotNetProtectorLicense>");
            sw.WriteLine("  <License ProductKey=\"{0}\" LicenseKey=\"{1}\" />", ProductKey, stLicence);
            sw.WriteLine("</dotNetProtectorLicense>");
            sw.Flush();
            byte[] data = ms.ToArray();
            ms.Close();
            FileStream fs = null;
            for (int i = 0; i < 10; i++)
            {
                try
                {
                    fs = new FileStream(AssemblyFile + ".license", FileMode.Create, FileAccess.ReadWrite, FileShare.None);
                }
                catch (IOException)
                {
                    System.Threading.Thread.Sleep(5);
                    continue;
                }
                fs.Write(data, 0, data.Length);
                fs.Close();
                break;
            }
            return 0x50764F6B;
        }
	}

}
