﻿using System;
using System.Collections.Generic;
using System.Reflection;
using System.Windows.Forms;

namespace Wizard
{
    static class Program
    {
        internal static Assembly AssemblyToActivate;
        internal static bool AllowInstant;
        internal static string ProductName;
        internal static string WizardTitle;

        static void SetProductName()
        {
            foreach (object o in AssemblyToActivate.GetCustomAttributes(typeof(AssemblyProductAttribute), false))
            {
                AssemblyProductAttribute ap = o as AssemblyProductAttribute;
                if (ap == null) continue;
                if (string.IsNullOrEmpty(ap.Product)) continue;
                ProductName = ap.Product;
                return;
            }
            foreach (object o in AssemblyToActivate.GetCustomAttributes(typeof(AssemblyTitleAttribute), false))
            {
                AssemblyTitleAttribute at = o as AssemblyTitleAttribute;
                if (at == null) continue;
                if (string.IsNullOrEmpty(at.Title)) continue;
                ProductName = at.Title;
                return;
            }
            ProductName = AssemblyToActivate.GetName().Name;
        }

        /// <summary>
        /// Point d'entrée principal de l'application.
        /// </summary>
        [STAThread]
        static int Main(string[] args)
        {
            object o = AppDomain.CurrentDomain.GetData("PvLog.dotNetProtector.SmartWizardFlags");
            if (o == null)
            {
                AllowInstant = false;
                
            }
            else
            {
                try
                {
                    uint flags = (uint)(int)o;
                    AllowInstant = (flags & 0x04000000) != 0;
                }
                catch
                {
                    AllowInstant = false;
                }
            }
            if (args.Length == 0)
            {
                AssemblyToActivate = PvLogiciels.dotNetProtector.Runtime.GetEntryAssembly();
            }
            else
            {
                AssemblyToActivate = Assembly.LoadFrom(args[0]);
            }
            SetProductName();
            WizardTitle = string.Format(Resources.WizardTitleFormat, ProductName);
            Application.EnableVisualStyles();
            try
            {
                Application.SetCompatibleTextRenderingDefault(false);
            }
            catch (Exception)
            {
                // Already called by wizard
                // Wizard called up to 3 times until it get activated or aborted by user
            }
            return MainClass.Run(null);
        }
    }
}