using System;
using System.Drawing;
using System.Collections;
using System.ComponentModel;
using System.Windows.Forms;

namespace Wizard
{
	/// <summary>
	/// Description rsume de Wizard1.
	/// </summary>
	internal class WizardMode : System.Windows.Forms.Form
	{
		private System.Windows.Forms.Button Suivant;
		public int wzAction;
		private System.Windows.Forms.Button Annuler;
        private System.Windows.Forms.Label label4;
        private System.Windows.Forms.Button Precedent;
        private RadioListBox modeRadioListBox;
		/// <summary>
		/// Variable ncessaire au concepteur.
		/// </summary>
		private System.ComponentModel.Container components = null;

		public WizardMode()
		{
			//
			// Requis pour la prise en charge du Concepteur Windows Forms
			//
			InitializeComponent();

            string[] Names;
            if (MainClass.PkMultiple)
            {
                int mask = 0x10;
                Names = Resources.NetKinds.Split('|');
                for (int i = 0; i < 5; i++)
                {
                    if ((MainClass.PkMultiKind & mask) != 0) modeRadioListBox.Items.Add(new RadioItem(Names[i], i + 256));
                    mask >>= 1;
                }
            }
            else
            {
                int mask = 1;
                Names = Resources.LocalKinds.Split('|');
                for (int i = 0; i < 5; i++)
                {
                    if ((MainClass.PkSingleKind & mask) != 0) modeRadioListBox.Items.Add(new RadioItem(Names[i], i));
                    mask <<= 1;
                }
                if (Program.AllowInstant) modeRadioListBox.Items.Add(new RadioItem(Resources.TxtInstant, 255));
            }

            if(modeRadioListBox.Items.Count>0) modeRadioListBox.SelectedIndex = 0;

            Text = Program.WizardTitle;
            wzAction = 0;
		}

        public int Value
        {
            get
            {
                RadioItem ri = modeRadioListBox.SelectedItem as RadioItem;
                if (ri == null) return 0;
                return ri.Value;
            }
        }

		/// <summary>
		/// Nettoyage des ressources utilises.
		/// </summary>
		protected override void Dispose( bool disposing )
		{
			if( disposing )
			{
				if(components != null)
				{
					components.Dispose();
				}
			}
			base.Dispose( disposing );
		}

		#region Code gnr par le Concepteur Windows Form
		/// <summary>
		/// Mthode requise pour la prise en charge du concepteur - ne modifiez pas
		/// le contenu de cette mthode avec l'diteur de code.
		/// </summary>
		private void InitializeComponent()
		{
            System.ComponentModel.ComponentResourceManager resources = new System.ComponentModel.ComponentResourceManager(typeof(WizardMode));
            this.Suivant = new System.Windows.Forms.Button();
            this.Annuler = new System.Windows.Forms.Button();
            this.label4 = new System.Windows.Forms.Label();
            this.Precedent = new System.Windows.Forms.Button();
            this.modeRadioListBox = new System.Windows.Forms.RadioListBox();
            this.SuspendLayout();
            // 
            // Suivant
            // 
            this.Suivant.DialogResult = System.Windows.Forms.DialogResult.OK;
            resources.ApplyResources(this.Suivant, "Suivant");
            this.Suivant.Name = "Suivant";
            this.Suivant.Click += new System.EventHandler(this.Suivant_Click);
            // 
            // Annuler
            // 
            this.Annuler.DialogResult = System.Windows.Forms.DialogResult.Abort;
            resources.ApplyResources(this.Annuler, "Annuler");
            this.Annuler.Name = "Annuler";
            this.Annuler.Click += new System.EventHandler(this.Annuler_Click);
            // 
            // label4
            // 
            resources.ApplyResources(this.label4, "label4");
            this.label4.Name = "label4";
            // 
            // Precedent
            // 
            this.Precedent.DialogResult = System.Windows.Forms.DialogResult.Cancel;
            resources.ApplyResources(this.Precedent, "Precedent");
            this.Precedent.Name = "Precedent";
            this.Precedent.Click += new System.EventHandler(this.Precedent_Click);
            // 
            // modeRadioListBox
            // 
            this.modeRadioListBox.BackColor = System.Drawing.Color.Transparent;
            this.modeRadioListBox.DrawMode = System.Windows.Forms.DrawMode.OwnerDrawFixed;
            this.modeRadioListBox.FormattingEnabled = true;
            resources.ApplyResources(this.modeRadioListBox, "modeRadioListBox");
            this.modeRadioListBox.Name = "modeRadioListBox";
            // 
            // WizardMode
            // 
            resources.ApplyResources(this, "$this");
            this.Controls.Add(this.modeRadioListBox);
            this.Controls.Add(this.Precedent);
            this.Controls.Add(this.label4);
            this.Controls.Add(this.Annuler);
            this.Controls.Add(this.Suivant);
            this.FormBorderStyle = System.Windows.Forms.FormBorderStyle.FixedDialog;
            this.MaximizeBox = false;
            this.MinimizeBox = false;
            this.Name = "WizardMode";
            this.TopMost = true;
            this.ResumeLayout(false);

		}
		#endregion

		private void Suivant_Click(object sender, System.EventArgs e)
		{
			wzAction=2;
			Close();
		}

		private void Annuler_Click(object sender, System.EventArgs e)
		{
			wzAction = 0;
			Close();
		}

		private void Precedent_Click(object sender, System.EventArgs e)
		{
			wzAction = 1;
			Close();
		}

        class RadioItem
        {
            public string Text { get; set; }
            public int Value { get; set; }

            public RadioItem(string t, int v)
            {
                Text = t;
                Value = v;
            }

            public override string ToString()
            {
                return Text;
            }
        }
	}
}
