using System;
using System.Drawing;
using System.Collections;
using System.ComponentModel;
using System.Windows.Forms;
using System.Threading;
using PvLogiciels.dotNetProtector;

namespace Wizard
{
	/// <summary>
	/// Description rsume de WizardWait.
	/// </summary>
	internal class WizardWait : System.Windows.Forms.Form
	{
		/// <summary>
		/// Variable ncessaire au concepteur.
		/// </summary>
		private System.ComponentModel.Container components = null;
		public string stLicence;
		private System.Windows.Forms.Button Precedent;
		private System.Windows.Forms.Button Suivant;
		private Thread theThread;
		string ActivationString;
		private System.Windows.Forms.TextBox tbTitre;
		private System.Windows.Forms.TextBox tbMessage;
		private System.Windows.Forms.Button Cancel;
		public int wzAction=0;

        delegate void DisplayResultDelegate(string result);

		public WizardWait(/*string Licence*/)
		{
			//
			// Requis pour la prise en charge du Concepteur Windows Forms
			//
			InitializeComponent();

			Cancel.Enabled=Precedent.Enabled=Suivant.Enabled=false;
            Text = Program.WizardTitle;

			//ActivationString=Licence;
			stLicence=null;
            //this.Load += new System.EventHandler(this.WizardWait_Load);
            System.Threading.ThreadPool.QueueUserWorkItem(new WaitCallback(GetLicence));
        }


		/// <summary>
		/// Nettoyage des ressources utilises.
		/// </summary>
		protected override void Dispose( bool disposing )
		{
			if( disposing )
			{
				if(components != null)
				{
					components.Dispose();
				}
			}
			base.Dispose( disposing );
		}

		#region Code gnr par le Concepteur Windows Form
		/// <summary>
		/// Mthode requise pour la prise en charge du concepteur - ne modifiez pas
		/// le contenu de cette mthode avec l'diteur de code.
		/// </summary>
		private void InitializeComponent()
		{
            System.ComponentModel.ComponentResourceManager resources = new System.ComponentModel.ComponentResourceManager(typeof(WizardWait));
            this.tbTitre = new System.Windows.Forms.TextBox();
            this.tbMessage = new System.Windows.Forms.TextBox();
            this.Cancel = new System.Windows.Forms.Button();
            this.Precedent = new System.Windows.Forms.Button();
            this.Suivant = new System.Windows.Forms.Button();
            this.SuspendLayout();
            // 
            // tbTitre
            // 
            this.tbTitre.AccessibleDescription = null;
            this.tbTitre.AccessibleName = null;
            resources.ApplyResources(this.tbTitre, "tbTitre");
            this.tbTitre.BackgroundImage = null;
            this.tbTitre.BorderStyle = System.Windows.Forms.BorderStyle.None;
            this.tbTitre.Name = "tbTitre";
            this.tbTitre.ReadOnly = true;
            this.tbTitre.TabStop = false;
            // 
            // tbMessage
            // 
            this.tbMessage.AccessibleDescription = null;
            this.tbMessage.AccessibleName = null;
            resources.ApplyResources(this.tbMessage, "tbMessage");
            this.tbMessage.BackgroundImage = null;
            this.tbMessage.BorderStyle = System.Windows.Forms.BorderStyle.None;
            this.tbMessage.Name = "tbMessage";
            this.tbMessage.ReadOnly = true;
            this.tbMessage.TabStop = false;
            // 
            // Cancel
            // 
            this.Cancel.AccessibleDescription = null;
            this.Cancel.AccessibleName = null;
            resources.ApplyResources(this.Cancel, "Cancel");
            this.Cancel.BackgroundImage = null;
            this.Cancel.DialogResult = System.Windows.Forms.DialogResult.Abort;
            this.Cancel.Font = null;
            this.Cancel.Name = "Cancel";
            this.Cancel.Click += new System.EventHandler(this.Cancel_Click);
            // 
            // Precedent
            // 
            this.Precedent.AccessibleDescription = null;
            this.Precedent.AccessibleName = null;
            resources.ApplyResources(this.Precedent, "Precedent");
            this.Precedent.BackgroundImage = null;
            this.Precedent.DialogResult = System.Windows.Forms.DialogResult.Cancel;
            this.Precedent.Font = null;
            this.Precedent.Name = "Precedent";
            this.Precedent.Click += new System.EventHandler(this.Precedent_Click);
            // 
            // Suivant
            // 
            this.Suivant.AccessibleDescription = null;
            this.Suivant.AccessibleName = null;
            resources.ApplyResources(this.Suivant, "Suivant");
            this.Suivant.BackgroundImage = null;
            this.Suivant.DialogResult = System.Windows.Forms.DialogResult.OK;
            this.Suivant.Font = null;
            this.Suivant.Name = "Suivant";
            this.Suivant.Click += new System.EventHandler(this.Suivant_Click);
            // 
            // WizardWait
            // 
            this.AccessibleDescription = null;
            this.AccessibleName = null;
            resources.ApplyResources(this, "$this");
            this.BackgroundImage = null;
            this.ControlBox = false;
            this.Controls.Add(this.Cancel);
            this.Controls.Add(this.Precedent);
            this.Controls.Add(this.Suivant);
            this.Controls.Add(this.tbMessage);
            this.Controls.Add(this.tbTitre);
            this.Cursor = System.Windows.Forms.Cursors.WaitCursor;
            this.Font = null;
            this.FormBorderStyle = System.Windows.Forms.FormBorderStyle.FixedDialog;
            this.Icon = null;
            this.MaximizeBox = false;
            this.MinimizeBox = false;
            this.Name = "WizardWait";
            this.TopMost = true;
            this.ResumeLayout(false);
            this.PerformLayout();

		}
		#endregion

        private void DisplayResult(string result)
        {
            string ErrorText = MainClass.txtUnKnownError;
            tbTitre.Text = MainClass.txtServerReponse;
            if (result != null)
            {
                if (result.StartsWith("*"))
                {
                    tbMessage.Lines = new string[] {
												   MainClass.txtActivationError,
												   MainClass.ActErrorMsg(result)
											   };
                }
                else
                {
                    tbMessage.Lines = new string[] {
                                                   //MainClass.txtActivationOk,
                                                   //result
												   MainClass.txtActivationOk
											   };
                    stLicence = result;
                }
            }
            else
            {
                tbMessage.Lines = new string[] { ErrorText };
            }
            Cancel.Enabled = Precedent.Enabled = true;
            Suivant.Enabled = stLicence != null;
            Cursor = Cursors.Arrow;
        }

        private void GetLicence(object instance)
        {
            GetLicence();
        }

		private void GetLicence()
		{
            
            string result = "";
            if (string.IsNullOrEmpty(MainClass.serverAddress))
            {
                if (MainClass.Mode == 1)
                    result = ActivationManager.ActivateUsb("http://activation.pvlog.com/dotNetProtectorActivationServer", Program.AssemblyToActivate, MainClass.ProductKey, MainClass.UsbHash, MainClass.UsbIdentity);
                else result = ActivationManager.Activate("http://activation.pvlog.com/dotNetProtectorActivationServer", Program.AssemblyToActivate, MainClass.ProductKey, (byte)(MainClass.Mode));
            }
            else
            {
                if (MainClass.Mode == 1)
                    result = ActivationManager.ActivateProxyUsb(MainClass.serverAddress, Program.AssemblyToActivate, MainClass.ProductKey, MainClass.UsbHash, MainClass.UsbIdentity);
                else if (MainClass.Mode < 256)
                    result = ActivationManager.ActivateProxy(MainClass.serverAddress, Program.AssemblyToActivate, MainClass.ProductKey, (byte)(MainClass.Mode));
                else result = ActivationManager.ActivateNetwork(MainClass.serverAddress, Program.AssemblyToActivate, MainClass.ProductKey, (byte)MainClass.NetSuffixes[MainClass.Mode - 256]);
            }
            Invoke(new DisplayResultDelegate(DisplayResult), result);

		}

		private void WizardWait_Load(object sender, System.EventArgs e)
		{
            ThreadStart ThreadFunc = new ThreadStart(GetLicence);
            theThread = new Thread(ThreadFunc);
            theThread.Start();
        }

		private void Cancel_Click(object sender, System.EventArgs e)
		{
			wzAction=0;
			Close();
		}

		private void Precedent_Click(object sender, System.EventArgs e)
		{
			wzAction=1;
			Close();
		}

		private void Suivant_Click(object sender, System.EventArgs e)
		{
			wzAction=2;
			Close();
		}
	}
}
